/****************************************************************************/
/*                  SQL Server Internals: The Practical Angle               */
/*                            PASS Summit 2015                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                          LOB Data and I/O                                */
/****************************************************************************/

set nocount on
go

use SqlServerInternals
go

if exists(
	select *
	from sys.tables t join sys.schemas s on
		t.schema_id = s.schema_id
	where
		t.name = 'Employees' and s.name = 'dbo'
)
	drop table dbo.Employees
go

create table dbo.Employees
(
	EmployeeId int not null,
	Name varchar(128) not null,
	Picture varbinary(max) null
);

;WITH N1(C) AS (SELECT 0 UNION ALL SELECT 0) -- 2 rows
,N2(C) AS (SELECT 0 FROM N1 AS T1 CROSS JOIN N1 AS T2) -- 4 rows
,N3(C) AS (SELECT 0 FROM N2 AS T1 CROSS JOIN N2 AS T2) -- 16 rows
,N4(C) AS (SELECT 0 FROM N3 AS T1 CROSS JOIN N3 AS T2) -- 256 rows
,N5(C) AS (SELECT 0 FROM N4 AS T1 CROSS JOIN N2 AS T2) -- 1,024 rows
,IDs(ID) AS (SELECT ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) FROM N5)
insert into dbo.Employees(EmployeeId, Name, Picture)
	select 
		ID, 'Employee ' + convert(varchar(5),ID), 
		convert(varbinary(max),replicate(convert(varchar(max),'a'),120000))
	from Ids
go

set statistics io, time on

select EmployeeId, Name from dbo.Employees;
select * from dbo.Employees;

set statistics io, time off 


