/****************************************************************************/
/*                  SQL Server Internals: The Practical Angle               */
/*                            PASS Summit 2015                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                       Row Size and Performance                           */
/****************************************************************************/

set nocount on
go

use SqlServerInternals
go

/*
create unique clustered index IDX_LargeRow_ID
on dbo.LargeRow(ID)
with (drop_existing = on, data_compression = none)
*/

-- checking # of the pages in the both tables
select page_count, * from sys.dm_db_index_physical_stats(DB_ID(),OBJECT_ID(N'LargeRow'),null, null, 'DETAILED')
select page_count, * from sys.dm_db_index_physical_stats(DB_ID(),OBJECT_ID(N'SmallRow'),null, null, 'DETAILED')
go

/* performance */
dbcc dropcleanbuffers
go

set statistics time, io on
select count(*) from dbo.LargeRow where IntField % 2 = 0
set statistics time, io off
go

dbcc dropcleanbuffers
go

set statistics time, io on
select count(*) from dbo.SmallRow where IntField % 2 = 0
set statistics time, io off
go

