/****************************************************************************/
/*                  SQL Server Internals: The Practical Angle               */
/*                            PASS Summit 2015                              */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                    Data Compression (Using demo DB)                      */
/****************************************************************************/

set nocount on
go

use SqlServerInternals
go

-- checking # of the pages in the both tables
select page_count, * from sys.dm_db_index_physical_stats(DB_ID(),OBJECT_ID(N'LargeRow'),null, null, 'DETAILED')
select page_count, * from sys.dm_db_index_physical_stats(DB_ID(),OBJECT_ID(N'SmallRow'),null, null, 'DETAILED')
go

exec sp_estimate_data_compression_savings 
	@schema_name = 'dbo'
	,@object_name = 'LargeRow'
	,@index_id = 1 -- Clustered Index
	,@partition_number = 1
	,@data_compression = 'PAGE'
go

create unique clustered index IDX_LargeRow_ID
on dbo.LargeRow(ID)
with (drop_existing = on, data_compression = page)
go